using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace Cotyounoyume
{
    public class WorldUI
    {
		#region Define vars
		public Atom UIAtomTemporary;
		public EBATCore core;
		public CustomUI customUi;
		public string UINameBase = "EBAT_UI_";
		public string UINameBaseTemporary = "EBAT_UITemporary_";
		
        MVRScript plugin;
		public WorldUIAddon1 worldUIAddon1;
		
		public bool isMinimize = false;
        public Canvas canvas;
        public Canvas canvasTemporary;
		public Vector3 canvasPos;
		public Quaternion canvasRot;
		
		public float defaultCanvasOffsetUp = 0.5f;
		public float defaultCanvasOffsetRight = 0.8f;
		public float defaultCanvasOffsetForward = 0.4f;
		
		public UIDynamic uiCorner     ;
		public UIDynamicButton uiMinimizeMenu;
		public UIDynamicButton uiPauseMenu;
		public UIDynamicButton uiCompactMenu;
		public UIDynamicButton uiCollapseWOBarUI;
		public string strMinimizeMenu = "❏";
		public string strMinimizeMenuAlt = "❏";
		public string strPauseMenu = "Suspend";
		public string strPauseMenuAlt = "Resume";
		public string strCompactMenu = "Compact";
		public string strCompactMenuAlt = "Normal";
		public string strCollapseWOBarUI = "❤Only";
		public string strCollapseWOBarUIAlt = "❤Recovery";
		public string strPauseMenuVar;
		public string strCompactMenuVar;
		public string strStatusFieldVar;
		public string strChangeSizeVar;
		public string strCollapseWOBarVar;
		
		public UIDynamicButton uiCloseMenu;
		public UIDynamicButton uiOpenAtomMenu;
		public UIDynamicButton uiCloseUI;
		public UIDynamicButton uiLookFrontUI;
		public UIDynamicButton uiReloadThisPluginOnly;
		public UIDynamicButton uiReloadPlugins;
		public UIDynamicButton uiChangeSize;
		public UIDynamicButton uiCollapseUI;
		public UIDynamicButton uiExpandAllUI;
		public string strChangeSize = "UI Size Small";
		public string strChangeSizeAlt = "UI Size Large";
		public string strOpenAtomMenu = "Open Atom UI";
		public string strCloseUI = "Close UI";
		public string strLookFrontUI = "LookFront";
		public string strCollapseUI = "Collapse UI";
		public string strExpandAllUI = "Expand UI";
		public string strReloadThisPluginOnly = "Reload This Plugin";
		public string strReloadPlugins = "Reload All Plugins";
		public string strCloseMenu    = "Close This Menu";

		public UIDynamicTextField uiStatusField;
		public UIDynamicTextField uiTemporaryText;
		public UIDynamicButton uiTemporaryButton;
		public string strStatusField = "The status of the Person is displayed here.";

		public UIDynamicButton uiOrgasmButton;
		public UIDynamicButton uiPeeButton;
		public UIDynamicButton uiResetExpressionButton;
		public UIDynamicButton uiCalmDownButton;
		public UIDynamicButton uiStageUp;
		public UIDynamicButton uiStageDown;
		public string strOrgasmButton    = "Make Her Orgasm";
		public string strOrgasmButtonAlt = "Stop Her Orgasm";
		public string strOrgasmButtonVar = "";
		public string strMaximinzeEcstasy = "Maximize Ecstasy";
		public string strPeeButton    = "Make Her Squirt";
		public string strCalmDownButton    = "Calm Her Down";
		public string strResetExpressionButton    = "Reset Expression";
		public string strStageUp    = "Stage Up";
		public string strStageDown = "Stage Down";
		
		public UIDynamicButton uiFaceForward;
		public UIDynamicButton uiFaceSideways;
		public UIDynamicButton uiFaceSidewaysAlt;
		public UIDynamicButton uiFaceSidewaysMax;
		public UIDynamicButton uiLookGlancing;
		public UIDynamicButton uiBackBending;
		public UIDynamicButton uiBackBendingStrong;
		public UIDynamicButton uiHint4;
		public string strFaceForward = "Face Forward";
		public string strFaceSideways = "Face Sideways(S)";
		public string strFaceSidewaysAlt = "Face Sideways(M)";
		public string strFaceSidewaysMax = "Face Sideways(L)";
		public string strLookGlancing = "Face Sideways(T)";
		public string strBackBending  = "Turn Head Back(T)";
		public string strBackBendingStrong  = "Turn Head Back(L)";
		public string strHint4   = "Help for Face Sideways...";
		
		public UIDynamicButton uiExpressionOnButton;
		public UIDynamicButton uiBlushingOnButton;
		public UIDynamicButton uiTearsOnButton;
		public UIDynamicButton uiDroolOnButton;			
		public string strExpressionOnButtonOn      = "Expression[ON]";
		public string strBlushingOnButtonOn        = "Blushing[ON]";
		public string strTearsOnButtonOn           = "Tears[ON]";
		public string strDroolOnButtonOn           = "Drool[ON]";
		public string strExpressionOnButtonOff     = "Expression[  ]";
		public string strBlushingOnButtonOff       = "Blushing[  ]";
		public string strTearsOnButtonOff          = "Tears[  ]";
		public string strDroolOnButtonOff          = "Drool[  ]";
		public string strExpressionOnButtonVar;
		public string strBlushingOnButtonVar;
		public string strTearsOnButtonVar;
		public string strDroolOnButtonVar;		
		
		public UIDynamicButton uiAutoExpressionOnButton;	
		public UIDynamicButton uiAutoBlinkOnButton;
		public UIDynamicButton uiEyesControlOnButton;
		public UIDynamicButton uiEyesRollupOnButton;		
		public string strAutoExpressionOnButtonOn  = "AutoExprOFF[ON]";
		public string strAutoBlinkOnButtonOn       = "AutoBlinkOFF[ON]";
		public string strEyesControlOnButtonOn     = "EyesControl[ON]";
		public string strEyesRollupOnButtonOn      = "EyesRollup[ON]";
		public string strAutoExpressionOnButtonOff = "AutoExpression[  ]";
		public string strAutoBlinkOnButtonOff      = "AutoBlink[  ]";
		public string strEyesControlOnButtonOff    = "EyesControl[  ]";
		public string strEyesRollupOnButtonOff     = "EyesRollup[  ]";
		public string strAutoExpressionOnButtonVar;
		public string strAutoBlinkOnButtonVar;
		public string strEyesControlOnButtonVar;
		public string strEyesRollupOnButtonVar;
		
		public UIDynamicButton uiSoundOnButton;
		public UIDynamicButton uiSoundVammButton;
		public UIDynamicButton uiPeeingOnButton;			
		public UIDynamicButton uiHint10;
		public string strSoundOnButtonOn             = "Sound[ON]";
		public string strSoundVammButtonOn           = "Use VAMMoan[ON]";
		public string strPeeingOnButtonOn            = "Peeing[ON]";
		public string strSoundOnButtonOff            = "Sound[  ]";		
		public string strSoundVammButtonOff          = "Use VAMMoan[  ]";
		public string strPeeingOnButtonOff           = "Peeing[  ]";
		public string strSoundOnButtonVar;
		public string strSoundVammButtonVar;
		public string strPeeingOnButtonVar;
		public string strHint10   = "Help for Use VAMMoan...";
		
		public UIDynamicButton uiHeadMotionOnButton;
		public UIDynamicButton uiToggleDoubleCollider;
		public UIDynamicButton uiSensitiveTriggerButton;
		public UIDynamicButton uiPenisSupportButton;
		public UIDynamicButton uiAlterSkinWrapButton;
		public UIDynamicButton uiHint2;
		public UIDynamicButton uiHint5;
		public UIDynamicButton uiHint11;
		public string strHeadMotionOnButtonON    = "HeadMotion[ON]";
		public string strToggleDoubleColliderOn  = "2x Collider Radius[ON]";
		public string strSensitiveTriggerOn      = "Sensitive Trigger[ON]";
		public string strPenisSupportOn          = "Penis Support[ON]";
		public string strAlterSkinWrapOn         = "Alter SkinWrap[ON]";
		public string strSensitiveTriggerOff     = "Sensitive Trigger[  ]";
		public string strHeadMotionOnButtonOff   = "HeadMotion[  ]";
		public string strToggleDoubleColliderOff = "2x Collider Radius[  ]";
		public string strPenisSupportOff         = "Penis Support[  ]";
		public string strAlterSkinWrapOff        = "Alter SkinWrap[  ]";
		public string strHeadMotionOnButtonVar;
		public string strToggleDoubleColliderVar;
		public string strSensitiveTriggerVar;
		public string strPenisSupportVar;
		public string strAlterSkinWrapVar;
		public string strHint2   = "Help for 2x Collider...";
		public string strHint5   = "Help for Sensitive...";
		public string strHint11  = "Help for SkinWrap...";
		
		public UIDynamicButton uiAutoStopPluginsButton;
		public UIDynamicButton uiAutoStopMorphButton;
		public UIDynamicButton uiAutoStopHeadButton;
		public UIDynamicButton uiAutoStopBodyButton;
		public UIDynamicButton uiHint3;
		public UIDynamicButton uiHint6;
		public UIDynamicButton uiHint7;
		public UIDynamicButton uiHint8;
		public string strAutoStopPluginsOn  = "AutoStop Plugins[ON]";
		public string strAutoStopMorphOn    = "AutoStop Morph[ON]";
		public string strAutoStopHeadOn     = "AutoStop Head[ON]";
		public string strAutoStopBodyOn     = "AutoStop Body[ON]";
		public string strAutoStopPluginsOff = "AutoStop Plugins[  ]";
		public string strAutoStopMorphOff   = "AutoStop Morph[  ]";
		public string strAutoStopHeadOff    = "AutoStop Head[  ]";
		public string strAutoStopBodyOff    = "AutoStop Body[  ]";
		public string strAutoStopPluginsVar = "";
		public string strAutoStopMorphVar   = "";
		public string strAutoStopHeadVar    = "";
		public string strAutoStopBodyVar    = "";
		public string strHint3   = "Help for Stop Plugins...";
		public string strHint6   = "Help for Stop Morph...";
		public string strHint7   = "Help for Stop Head...";
		public string strHint8   = "Help for Stop Body...";
		
		public UIDynamicButton uiNippleErectionOnButton;	
		public UIDynamicButton uiClitorisErectionOnButton;
		public UIDynamicButton uiShiveringBoneButton;
		public UIDynamicButton uiShiveringMorphButton;
		public UIDynamicButton uiHint9;
		public string strNippleErectionOnButtonOn    = "NippleErection[ON]";
		public string strClitorisErectionOnButtonOn  = "ClitorisErection[ON]";
		public string strNippleErectionOnButtonOff   = "NippleErection[  ]";
		public string strClitorisErectionOnButtonOff = "ClitorisErection[  ]";
		public string strNippleErectionOnButtonVar;
		public string strClitorisErectionOnButtonVar;
		public string strShiveringBoneOn    = "Shivering(Bone)[ON]";
		public string strShiveringBoneOff   = "Shivering(Bone)[  ]"  ;
		public string strShiveringMorphOn   = "Shivering(Morph)[ON]";
		public string strShiveringMorphOff  = "Shivering(Morph)[  ]"  ;
		public string strShiveringBoneVar   = "";
		public string strShiveringMorphVar  = "";
		public string strHint9   = "Help for Shivering...";
		
		public UIDynamicSlider uiStrengthSlider;
		public UIDynamicSlider uiWaveSlider;
		public UIDynamicSlider uiGaugeSlider;
		public UIDynamicSlider uiPitchSlider;
		public string strStrengthSlider = "Expression Strength";
		public string strWaveSlider = "Cycles of Orgasm(Max)";
		public string strGaugeSlider = "Ecstasy Level";
		public string strPitchSlider = "Sound Pitch";
		
		public UIDynamicButton uiExpandUI     ;
		public UIDynamicButton uiExpandAction1;
		public UIDynamicButton uiExpandAction2;
		public UIDynamicButton uiExpandConfig1;
		public UIDynamicButton uiExpandConfig2;
		public UIDynamicButton uiExpandConfig3;
		public UIDynamicButton uiExpandConfig4;
		public UIDynamicButton uiExpandSlider1;
		public UIDynamicButton uiExpandSlider2;
		public UIDynamicButton uiExpandSwitch;
		public UIDynamicButton uiExpandAddon  ;
		public UIDynamicButton uiExpandTest   ;
		
		public string strExpandUI         = "UI[▶]";
		public string strExpandAction1    = "Action1[▶]";
		public string strExpandAction2    = "Action2[▶]";
		public string strExpandConfig1    = "Config1[▶]";
		public string strExpandConfig2    = "Config2[▶]";
		public string strExpandConfig3    = "Config3[▶]";
		public string strExpandConfig4    = "Config4[▶]";
		public string strExpandSlider1    = "❤bar[▶]";
		public string strExpandSlider2    = "Slider[▶]";
		public string strExpandSwitch     = "Switch[▶]";
		public string strExpandAddon1     = "Addon1[▶]";
		public string strExpandAddon2     = "Addon2[▶]";
		public string strExpandTest       = "Test[▶]";

		public string strExpandUIAlt       = "UI[◀]";
		public string strExpandAction1Alt  = "Action1[◀]";
		public string strExpandAction2Alt  = "Action2[◀]";
		public string strExpandConfig1Alt  = "Config1[◀]";
		public string strExpandConfig2Alt  = "Config2[◀]";
		public string strExpandConfig3Alt  = "Config3[◀]";
		public string strExpandConfig4Alt  = "Config4[◀]";
		public string strExpandSlider1Alt  = "❤bar[◀]";
		public string strExpandSlider2Alt  = "Slider[◀]";
		public string strExpandSwitchAlt   = "Switch[◀]";
		public string strExpandAddon1Alt   = "Addon1[◀]";
		public string strExpandAddon2Alt   = "Addon2[◀]";
		public string strExpandTestAlt     = "Test[◀]";
		public string strGenderSVar  = "She";
		public string strGenderPVar = "her";
		public string strGenderOVar = "her";
		public string strExpandAlt = "[-]";

		public float spacerSizeX = 1000f;
		public float spacerSizeY = 600f;
		public float buttonSizeX = 200f;
		public float buttonSizeX3 = 800f;
		public float buttonSizeY  = 40f;
		public float buttonSizeY2 = 90f;
		public float buttonSizeY3 = 140f;
		public float buttonSizeY4 = 190f;
		public float buttonSizeY5 = 240f;
		public float toggleSizeX = 200f;
		public float toggleSizeY = 40f;
		public float sliderSizeX = 400f;
		public float sliderSizeY  =  80f;
		public float sliderSizeY2 = 180f;
		public float sliderSizeY3 = 280f;
		public float headerX = 50f;
		public float buttonSizeMinimizeX = 10f;
		public int fontSize = 26;
		
		private float xSpacing = 0.3f;
		private float xIndent = 0.15f;
		private float ySpacing = -0.05f;
		private float xOffsetMinimize = 0.08f;
		private float xOffset = 0.04f;
		private float yOffset = -0.08f;
        private float UIScale;
		private float smallRatio = 0.75f;
		private float smallRatioForSize = 0.80f;
		private float quick1 = 1.75f;
		private float quick2 = 2.35f;
		private float quick3 = 2.95f;
		private float quick4 = 3.55f;
		
		public int fontSizeAlt = 20;

		public bool isSmall = false;
		public bool isCompact = false;
		public bool isBarOnly = false;

		public string strInstantSoundLow    = "Low(0.9)";
		public string strInstantSoundMiddle = "Middle(1.0)";
		public string strInstantSoundHigh   = "High(1.2)";
		public UIDynamicButton uiInstantSoundLow;
		public UIDynamicButton uiInstantSoundMiddle;
		public UIDynamicButton uiInstantSoundHigh;

		public string strInstantStrengthLow    = "Low(0.8)";
		public string strInstantStrengthMiddle = "Middle(1.0)";
		public string strInstantStrengthHigh   = "High(1.1)";
		public UIDynamicButton uiInstantStrengthLow;
		public UIDynamicButton uiInstantStrengthMiddle;
		public UIDynamicButton uiInstantStrengthHigh;

		public string strInstantWaveLow    = "Low(5)";
		public string strInstantWaveMiddle = "Middle(10)";
		public string strInstantWaveHigh   = "High(20)";
		public string strInstantWave999    = "999";
		public UIDynamicButton uiInstantWaveLow;
		public UIDynamicButton uiInstantWaveMiddle;
		public UIDynamicButton uiInstantWaveHigh;
		public UIDynamicButton uiInstantWave999;

		public string[] expandKeys = {
			"UI", "Action1", "Action2", "Config1", "Config2", "Config3", "Config4", "Slider1", "Slider2", 
			"Addon1", "Addon2", "Test",
		};
		public Dictionary<string, bool> expandState = new Dictionary<string, bool>();
		public Dictionary<string, bool> beforeBarOnlyState = new Dictionary<string, bool>();
		
		public int line = 0;
		public int lineMainLast = 0;
		
		#endregion
		
		#region common
        public WorldUI(EBATCore core, float scale = 0.002f)
        {
            this.plugin = core as MVRScript;
            this.UIScale = scale;
			this.core = core;
			this.canvasPos = new Vector3(0f, 0f, 0f);
			this.canvasRot = new Quaternion(0f, 0f, 0f, 0f);
			this.lineMainLast = 0;
        }
		
		public void loadSettings(){
			try{
				this.customUi = core.customUi;
				expandState.Clear(); 
				beforeBarOnlyState.Clear(); 

				if(!core.settingsRoot["Common"].AsObject.HasKey("Default Position")){
					core.settingsRoot["Common"]["Default Position"]["Up"]      = defaultCanvasOffsetUp.ToString();
					core.settingsRoot["Common"]["Default Position"]["Right"]   = defaultCanvasOffsetRight.ToString();
					core.settingsRoot["Common"]["Default Position"]["Forward"] = defaultCanvasOffsetForward.ToString();
				}else{
					defaultCanvasOffsetUp      = core.settingsRoot["Common"]["Default Position"]["Up"].AsFloat;
					defaultCanvasOffsetRight   = core.settingsRoot["Common"]["Default Position"]["Right"].AsFloat;
					defaultCanvasOffsetForward = core.settingsRoot["Common"]["Default Position"]["Forward"].AsFloat;		
				}
				
				foreach(var key in expandKeys){
					expandState.Add(key, true);
					beforeBarOnlyState.Add(key, true);
				}
				beforeBarOnlyState.Add("isCompact", isCompact);
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void ResetCanvasPosition(){
			defaultCanvasOffsetUp      = core.settingsRoot["Common"]["Default Position"]["Up"].AsFloat;
			defaultCanvasOffsetRight   = core.settingsRoot["Common"]["Default Position"]["Right"].AsFloat;
			defaultCanvasOffsetForward = core.settingsRoot["Common"]["Default Position"]["Forward"].AsFloat;		
			
			core.UIAtom.mainController.transform.position = Utility.getPositionFromTargetBodyname(core.atom, "headControl");
			core.UIAtom.mainController.transform.Translate(Vector3.up * defaultCanvasOffsetUp);
			core.UIAtom.mainController.transform.Translate(Vector3.right * defaultCanvasOffsetRight);
			core.UIAtom.mainController.transform.Translate(Vector3.forward * defaultCanvasOffsetForward);
		}
		
		public void applySettings(){
			try{
				strOrgasmButtonVar = (core.isDuringOrgasm || core.isDuringAfterglow) ? strOrgasmButtonAlt : strOrgasmButton;
				strGenderSVar = (core.gender=="Male") ? "He" : "She";
				strGenderPVar = (core.gender=="Male") ? "his" : "her";
				strGenderOVar = (core.gender=="Male") ? "him" : "her";
				
				worldUIAddon1 = new WorldUIAddon1(this);
//				core.DoWorldUIAddon2Function("Construct");
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void SetCanvasPosition(){
			canvasPos.x = customUi.jsCanvasPositionX.val;
			canvasPos.y = customUi.jsCanvasPositionY.val;
			canvasPos.z = customUi.jsCanvasPositionZ.val;
			
			canvasRot.x = customUi.jsCanvasRotationX.val;
			canvasRot.y = customUi.jsCanvasRotationY.val;
			canvasRot.z = customUi.jsCanvasRotationZ.val;
			canvasRot.w = customUi.jsCanvasRotationW.val;
		}
		
		public void OnDestroy()
		{
			RemoveMenuBody();
			RemoveMenuBodyTemporary();
			worldUIAddon1.RemoveMenuBodyAddon();
			core.DoWorldUIAddon2Function("RemoveMenuBodyAddon");
			RemoveMenuBase();
			core.RemoveGameObjectByName("SphereForUICorner");
			
//			expandKeys.Clear();
			expandState.Clear();
			beforeBarOnlyState.Clear();
		}
		#endregion
				
		#region Make Base UI
		public void makeWorldUI(){
			if(!core.menuOnGlobal){
				return;
			}
			MakeMenuBase();
			MakeMenuBase("temporary");
			core.versionCheck();
			strCompactMenuVar = isCompact ? strCompactMenuAlt : strCompactMenu;
			strCollapseWOBarVar = isBarOnly ? strCollapseWOBarUIAlt : strCollapseWOBarUI;
			if(core.launchMode == "normal"){
				ExpandMenu();
			}else if(core.launchMode == "paused"){
				strPauseMenuVar = strPauseMenuAlt;
				MakeMenuBodyPartMinAltPaused();
			}
		}
		
		public void MakeMenuBodyIfNeeded(){
			if(core.launchMode == "normal"){
				ExpandMenu();
			}else if(core.launchMode == "paused"){
				strPauseMenuVar = strPauseMenuAlt;
				MakeMenuBodyPartMinAltPaused();
			}
		}		

		public void RemoveMenuAll(){
			RemoveMenuBody();
		}
		
		public void RemoveMenuBase(){
			if (core.UIAtom != null){
				SuperController.singleton.RemoveAtom(core.UIAtom);
			}
			if (UIAtomTemporary != null){
				SuperController.singleton.RemoveAtom(UIAtomTemporary);
			}
			if (SuperController.singleton != null){
				SuperController.singleton.RemoveCanvas(canvas);
			}			
			if (SuperController.singleton != null){
				SuperController.singleton.RemoveCanvas(canvasTemporary);
			}			
		}
		
		
		public void MakeMenuBase(string type = ""){
			Vector3 headPosition = Utility.getPositionFromTargetBodyname(core.atom, "headControl");
			float upOffset      = (type == "temporary") ?  0.2f : defaultCanvasOffsetUp;
			float rightOffset   = (type == "temporary") ? -0.2f : defaultCanvasOffsetRight;
			float forwardOffset = (type == "temporary") ?  0.0f : defaultCanvasOffsetForward;
			string UIName = (type == "temporary") ? UINameBaseTemporary : UINameBase;
			if(core.UIAtom == null){
				MakeCanvas(type, upOffset, rightOffset, forwardOffset);
				
				core.StartCoroutine(core.CreateAtom("Empty", UIName, (tmpatom)=>
				{
					Utility.LookFront(tmpatom.mainController.transform);
					tmpatom.mainController.transform.position = Utility.getPositionFromTargetBodyname(core.atom, "headControl");
					tmpatom.mainController.transform.Translate(Vector3.up * upOffset);
					tmpatom.mainController.transform.Translate(Vector3.right * rightOffset);
					tmpatom.mainController.transform.Translate(Vector3.forward * forwardOffset);
			
					Canvas tmpCanvas = (type == "temporary") ? canvasTemporary : canvas;
					tmpCanvas.transform.SetParent(tmpatom.mainController.transform, true);
					if(type == "temporary"){
						UIAtomTemporary = tmpatom;
					}else{
						core.UIAtom = tmpatom;
					}
					if(type != "temporary"){
						core.customUnityAssetItem.MakeSphereForUI(core.UIAtom.mainController.transform);
					}
				}));
			}else{
				if(type != "temporary"){
					core.customUnityAssetItem.MakeSphereForUI(core.UIAtom.mainController.transform);
				}
			}
			
			if(customUi.jsCanvasPositionX.val == 0f){
				canvasPos = Utility.getPosition(canvas.transform);
			}else{
				SetCanvasPosition();
			}
		}
		
		public void MakeCanvas(string type = "", float upOffset = 0f, float rightOffset = 0f, float forwardOffset = 0f){
            GameObject canvasObject = new GameObject();
			Canvas tmpCanvas = null;
            tmpCanvas = canvasObject.AddComponent<Canvas>();
            tmpCanvas.renderMode = RenderMode.WorldSpace;
            tmpCanvas.pixelPerfect = false;
            SuperController.singleton.AddCanvas(tmpCanvas);

            CanvasScaler cs = canvasObject.AddComponent<CanvasScaler>();
            cs.scaleFactor = 100.0f;
            cs.dynamicPixelsPerUnit = 1f;

            GraphicRaycaster gr = canvasObject.AddComponent<GraphicRaycaster>();

            tmpCanvas.transform.localScale = new Vector3(this.UIScale, this.UIScale, this.UIScale);
			Utility.LookFront(tmpCanvas.transform);
			
			Vector3 headPosition = Utility.getPositionFromTargetBodyname(core.atom, "headControl");
			tmpCanvas.transform.position = Utility.getPositionFromTargetBodyname(core.atom, "headControl");
			tmpCanvas.transform.Translate(Vector3.up * upOffset);
			tmpCanvas.transform.Translate(Vector3.right * rightOffset);
			tmpCanvas.transform.Translate(Vector3.forward * forwardOffset);
			if(type == "temporary"){
				canvasTemporary = tmpCanvas;
			}else{
				canvas = tmpCanvas;
			}
		}
		
		public void SetExpandValue(string type){
			if(type == "Expand"){
				foreach(var key in expandKeys){
					if(key == "Addon1"){
						worldUIAddon1.OnExpandCommonValueOnly("Addon1");
					}else if(key == "Addon2"){
						core.DoWorldUIAddon2Function("ExpandAddon2All");
					}else{
						expandState[key] = true;
					}
				}
			}else if(type == "Collapse"){
				foreach(var key in expandKeys){
					if(key == "Addon1"){
						worldUIAddon1.OnCollapseCommonValueOnly("Addon1");
					}else if(key == "Addon2"){
						core.DoWorldUIAddon2Function("CollapseAddon2All");
					}else{
						expandState[key] = false;
					}
				}
			}else if(type == "Recovery"){
				foreach(var key in expandKeys){
					expandState[key] = beforeBarOnlyState[key];
					if(key == "Addon1"){
						if(expandState[key]){
							worldUIAddon1.OnExpandCommonValueOnly("Addon1");
						}else{
							worldUIAddon1.OnCollapseCommonValueOnly("Addon1");
						}
					}else if(key == "Addon2"){
						if(expandState[key]){
							core.DoWorldUIAddon2Function("ExpandAddon2All");
						}else{
							core.DoWorldUIAddon2Function("CollapseAddon2All");
						}
					}
				}
				isCompact = beforeBarOnlyState["isCompact"];
			}else if(type == "BarOnly"){
				foreach(var key in expandKeys){
					beforeBarOnlyState[key] = expandState[key];
					if(key == "Addon1"){
						worldUIAddon1.OnCollapseCommonValueOnly("Addon1");
					}else if(key == "Addon2"){
						core.DoWorldUIAddon2Function("CollapseAddon2All");
					}else if(key == "Slider1"){
						expandState[key] = true;
					}else{
						expandState[key] = false;
					}
				}
				beforeBarOnlyState["isCompact"] = isCompact;
				isCompact = true;
			}
		}
		#endregion
		
		#region Make UI Body
		public void MakeMenuBody(){
			line = 0;
			strCompactMenuVar = isCompact ? strCompactMenuAlt : strCompactMenu;
			strCollapseWOBarVar = isBarOnly ? strCollapseWOBarUIAlt : strCollapseWOBarUI;
			MakeMenuBodyMain();
			lineMainLast = line;
			lineMainLast -= 2;
			worldUIAddon1.MakeMenuBodyAddon();
			core.DoWorldUIAddon2Function("MakeMenuBodyAddon");
			LabelSwitch();
			Coloring();
		}
		
		public void MakeMenuBodyMain(){
			MakeMenuBodyPartMin();
			
			if(expandState["Slider1"]){
				line++;
				MakeMenuBodyPartCollapseButton("Slider1", line);
				MakeMenuBodyPartSlider1();
			}else{
				if(!isCompact){
					MakeMenuBodyPartExpandButton("Slider1");
				}
			}
			
			if(expandState["UI"]){
				MakeMenuBodyPartCollapseButton("UI", line + 1);
				MakeMenuBodyPartUI();
			}else{
				if(!isCompact){
					MakeMenuBodyPartExpandButton("UI");
				}
			}
			
			if(expandState["Action1"]){
				MakeMenuBodyPartCollapseButton("Action1", line + 1);
				MakeMenuBodyPartAction1();
			}else{
				if(!isCompact){
					MakeMenuBodyPartExpandButton("Action1");
				}
			}
						
			if(expandState["Action2"]){
				MakeMenuBodyPartCollapseButton("Action2", line + 1);
				MakeMenuBodyPartAction2();
			}else{
				if(!isCompact){
					MakeMenuBodyPartExpandButton("Action2");
				}
			}
						
			if(expandState["Config1"]){
				MakeMenuBodyPartCollapseButton("Config1", line + 1);
				MakeMenuBodyPartConfig1();
			}else{
				if(!isCompact){
					MakeMenuBodyPartExpandButton("Config1");
				}
			}
			
			if(expandState["Config2"]){
//				MakeMenuBodyPartCollapseButton("Config2", line + (core.worldUi.isCompact ? 1 : 2));
				MakeMenuBodyPartCollapseButton("Config2", line + 2);
				MakeMenuBodyPartConfig2();
			}else{
				if(!isCompact){
					MakeMenuBodyPartExpandButton("Config2");
				}
			}
			
			if(expandState["Config3"]){
				MakeMenuBodyPartCollapseButton("Config3", line + (core.worldUi.isCompact ? 0 : 1));
				MakeMenuBodyPartConfig3();
			}else{
				if(!isCompact){
					MakeMenuBodyPartExpandButton("Config3");
				}
			}

			if(expandState["Config4"]){
				MakeMenuBodyPartCollapseButton("Config4", line + (core.orgasmModeOn ? 1 : 0));
				MakeMenuBodyPartConfig4();
			}else{
				if(!isCompact){
					MakeMenuBodyPartExpandButton("Config4");
				}
			}
			
			if(expandState["Slider2"]){
				line++;
				int tmpLine = line + (core.orgasmModeOn ? 4 : 2);
				MakeMenuBodyPartCollapseButton("Slider2", tmpLine);
				MakeMenuBodyPartSlider2();
			}else{
				if(!isCompact){
					MakeMenuBodyPartExpandButton("Slider2");
				}
			}
//			LabelSwitch();
		}
		
		public void MakeMenuBodyPartExpandButton(string type){
			if(type == "UI"){
				uiExpandUI = MakeButton(strExpandUI, -1, line);
				uiExpandUI.button.onClick.AddListener(OnExpandUI);
			}else if(type == "Action1"){
				uiExpandAction1 = MakeButton(strExpandAction1, -1, line);
				uiExpandAction1.button.onClick.AddListener(OnExpandAction1);
			}else if(type == "Action2"){
				uiExpandAction2 = MakeButton(strExpandAction2, -1, line);
				uiExpandAction2.button.onClick.AddListener(OnExpandAction2);
			}else if(type == "Config1"){
				uiExpandConfig1 = MakeButton(strExpandConfig1, -1, line);
				uiExpandConfig1.button.onClick.AddListener(OnExpandConfig1);
			}else if(type == "Config2"){
				uiExpandConfig2 = MakeButton(strExpandConfig2, -1, line);
				uiExpandConfig2.button.onClick.AddListener(OnExpandConfig2);
			}else if(type == "Config3"){
				uiExpandConfig3 = MakeButton(strExpandConfig3, -1, line);
				uiExpandConfig3.button.onClick.AddListener(OnExpandConfig3);
			}else if(type == "Config4"){
				uiExpandConfig4 = MakeButton(strExpandConfig4, -1, line);
				uiExpandConfig4.button.onClick.AddListener(OnExpandConfig4);
			}else if(type == "Slider1"){
				uiExpandSlider1 = MakeButton(strExpandSlider1, -1, line);
				uiExpandSlider1.button.onClick.AddListener(OnExpandSlider1);
			}else if(type == "Slider2"){
				uiExpandSlider2 = MakeButton(strExpandSlider2, -1, line);
				uiExpandSlider2.button.onClick.AddListener(OnExpandSlider2);
			}			
			line++;
		}
		
		public void MakeMenuBodyPartCollapseButton(string type, int tmpLine){
			if(type == "UI"){
				uiExpandUI = MakeButton(strExpandUIAlt, -1, tmpLine, height:buttonSizeY2);
				uiExpandUI.button.onClick.AddListener(OnCollapseUI);
			}else if(type == "Action1"){
				uiExpandAction1 = MakeButton(strExpandAction1Alt, -1, tmpLine, height:buttonSizeY2);
				uiExpandAction1.button.onClick.AddListener(OnCollapseAction1);
			}else if(type == "Action2"){
				uiExpandAction2 = MakeButton(strExpandAction2Alt, -1, tmpLine, height:buttonSizeY2);
				uiExpandAction2.button.onClick.AddListener(OnCollapseAction2);
			}else if(type == "Config1"){
				uiExpandConfig1 = MakeButton(strExpandConfig1Alt, -1, tmpLine, height:buttonSizeY2);
				uiExpandConfig1.button.onClick.AddListener(OnCollapseConfig1);
			}else if(type == "Config2"){
//				float tmpButtonHeight = (!core.worldUi.isCompact) ? buttonSizeY3 : buttonSizeY2;
//				uiExpandConfig2 = MakeButton(strExpandConfig2Alt, -1, tmpLine, height:tmpButtonHeight);
				uiExpandConfig2 = MakeButton(strExpandConfig2Alt, -1, tmpLine, height:buttonSizeY3);
				uiExpandConfig2.button.onClick.AddListener(OnCollapseConfig2);
			}else if(type == "Config3"){
				float tmpButtonHeight = (!core.worldUi.isCompact) ? buttonSizeY2 : buttonSizeY;
				uiExpandConfig3 = MakeButton(strExpandConfig3Alt, -1, tmpLine, height:tmpButtonHeight);
				uiExpandConfig3.button.onClick.AddListener(OnCollapseConfig3);
			}else if(type == "Config4"){
				bool isOrgasmOn = core.orgasmModeOn ? true : false;
				if(isOrgasmOn){
					uiExpandConfig4 = MakeButton(strExpandConfig4Alt, -1, tmpLine, height:buttonSizeY2);
				}else{
					uiExpandConfig4 = MakeButton(strExpandConfig4Alt, -1, tmpLine, height:buttonSizeY);
				}
				uiExpandConfig4.button.onClick.AddListener(OnCollapseConfig4);
			}else if(type == "Slider1"){
				uiExpandSlider1 = MakeButton(strExpandSlider1Alt, -1, tmpLine, height:sliderSizeY);
				uiExpandSlider1.button.onClick.AddListener(OnCollapseSlider1);
			}else if(type == "Slider2"){
				bool isOrgasmOn = core.orgasmModeOn ? true : false;
				if(isOrgasmOn){
					uiExpandSlider2 = MakeButton(strExpandSlider2Alt, -1, tmpLine, height:sliderSizeY3);
				}else{
					uiExpandSlider2 = MakeButton(strExpandSlider2Alt, -1, tmpLine, height:sliderSizeY2);
				}
				uiExpandSlider2.button.onClick.AddListener(OnCollapseSlider2);
			}
		}
		
		public void MakeMenuBodyPartMin(){
			uiCorner = MakeSpacer(-1, line);
			
			uiMinimizeMenu = MakeButton(strMinimizeMenu, -1, line, isMinimizeButton:true);
			uiPauseMenu = MakeButton(strPauseMenuVar, 0, 0, width:20f);
			uiPauseMenu.button.onClick.AddListener(OnPauseClick);			
			uiCompactMenu = MakeButton(strCompactMenuVar, 1, 0, width:20f, isMinisizeButton:true);
			uiCompactMenu.button.onClick.AddListener(OnCompactClick);			
			uiCollapseWOBarUI = MakeButton(strCollapseWOBarUI, 2, 0, width:20f, isMinisizeButton:true);
			uiCollapseWOBarUI.button.onClick.AddListener(OnCollapseWOBarUIClick);
			uiLookFrontUI = MakeButton(strLookFrontUI, 3, 0, width:20f, isMinisizeButton:true);
			uiLookFrontUI.button.onClick.AddListener(OnLookFrontClick);
			line++;
			uiMinimizeMenu.button.onClick.AddListener(OnMinimizeMenuClick);	
			isMinimize = false;
		}

		public void MakeMenuBodyPartMinAlt(){
			MakeSpacer(-1, line);
			
			uiMinimizeMenu = MakeButton(strMinimizeMenuAlt, -1, 0, isMinimizeButton:true);
			uiMinimizeMenu.button.onClick.AddListener(ExpandMenu);
			uiPauseMenu = MakeButton(strPauseMenuVar, 0, 0, width:20f);
			uiPauseMenu.button.onClick.AddListener(OnPauseClick);			
			uiCompactMenu = MakeButton(strCompactMenuVar, 1, 0, width:20f, isMinisizeButton:true);
			uiCompactMenu.button.onClick.AddListener(OnCompactClick);			
			uiCollapseWOBarUI = MakeButton(strCollapseWOBarUI, 2, 0, width:20f, isMinisizeButton:true);
			uiCollapseWOBarUI.button.onClick.AddListener(OnCollapseWOBarUIClick);
			uiLookFrontUI = MakeButton(strLookFrontUI, 3, 0, width:20f, isMinisizeButton:true);
			uiLookFrontUI.button.onClick.AddListener(OnLookFrontClick);
			Coloring();
			LabelSwitchPauseOnly();			
			isMinimize = true;
		}
		
		public void MakeMenuBodyPartMinAltPaused(){
			uiMinimizeMenu = MakeButton(strMinimizeMenuAlt, -1, 0, isMinimizeButton:true);
			uiPauseMenu = MakeButton(strPauseMenuVar, 0, 0, width:20f);
			uiPauseMenu.button.onClick.AddListener(OnPauseEndClick);
			Coloring();
			LabelSwitchPauseOnly();			
		}
		
		public void MakeMenuBodyPartUI(){
			uiChangeSize = MakeButton(strChangeSizeVar, 0, line);
			uiOpenAtomMenu = MakeButton(strOpenAtomMenu, 1, line);
			uiCloseUI = MakeButton(strCloseUI, 2, line);
			uiCloseMenu = MakeButton(strCloseMenu, 3, line);
			line++;
			
			uiCollapseUI = MakeButton(strCollapseUI, 0, line);
			uiExpandAllUI = MakeButton(strExpandAllUI, 1, line);
			uiReloadThisPluginOnly = MakeButton(strReloadThisPluginOnly, 2, line);
			uiReloadPlugins = MakeButton(strReloadPlugins, 3, line);
			line++;
			
			uiChangeSize.button.onClick.AddListener(OnChangeSizeClick);
			uiCloseMenu.button.onClick.AddListener(OnCloseMenuClick);
			uiOpenAtomMenu.button.onClick.AddListener(OnOpenAtomMenuClick);
			uiCloseUI.button.onClick.AddListener(OnCloseUIClick);
			uiReloadPlugins.button.onClick.AddListener(OnReloadPluginsClick);
			uiReloadThisPluginOnly.button.onClick.AddListener(OnReloadThisPluginOnlyClick);
			uiCollapseUI.button.onClick.AddListener(OnCollapseUIClick);
			uiExpandAllUI.button.onClick.AddListener(OnExpandAllUIClick);
		}
		
		public void MakeMenuBodyPartAction1(){
			//orgasm class relatives
			string strEcstasyVar = core.orgasmModeOn ? strOrgasmButtonVar : strMaximinzeEcstasy;
			uiOrgasmButton = MakeButton(strEcstasyVar, 0, line);
			uiPeeButton = MakeButton(strPeeButton, 1, line);
			uiCalmDownButton = MakeButton(strCalmDownButton, 2, line);
			uiResetExpressionButton = MakeButton(strResetExpressionButton, 3, line);
			line++;
			uiStageUp   = MakeButton(strStageUp,   0, line);
			uiStageDown = MakeButton(strStageDown, 1, line);
			line++;
			
			uiOrgasmButton.button.onClick.AddListener(OnOrgasmButtonClick);
			uiPeeButton.button.onClick.AddListener(OnPeeButtonClick);
			uiCalmDownButton.button.onClick.AddListener(OnCalmDownButtonClick);
			uiResetExpressionButton.button.onClick.AddListener(OnResetExpressionButton);
			uiStageUp.button.onClick.AddListener(OnStageUp);
			uiStageDown.button.onClick.AddListener(OnStageDown);
		}

		public void MakeMenuBodyPartAction2(){
			//orgasm class relatives
			uiFaceForward  = MakeButton(strFaceForward,  0, line);
			uiBackBending  = MakeButton(strBackBending,  1, line);
			uiBackBendingStrong  = MakeButton(strBackBendingStrong,  2, line);
			
			if(!core.worldUi.isCompact){
				uiHint4                    = MakeButton(strHint4, 3, line);
			}
			line++;
			
			uiLookGlancing = MakeButton(strLookGlancing, 0, line);
			uiFaceSideways = MakeButton(strFaceSideways, 1, line);
			uiFaceSidewaysAlt = MakeButton(strFaceSidewaysAlt, 2, line);
			uiFaceSidewaysMax = MakeButton(strFaceSidewaysMax, 3, line);
			line++;
			
			uiFaceForward.button.onClick.AddListener(OnFaceForwardClick);
			uiLookGlancing.button.onClick.AddListener(OnLookGlancingClick);
			uiFaceSideways.button.onClick.AddListener(OnFaceSidewaysClick);
			uiFaceSidewaysAlt.button.onClick.AddListener(OnFaceSidewaysAltClick);
			uiFaceSidewaysMax.button.onClick.AddListener(OnFaceSidewaysMaxClick);
			uiBackBending.button.onClick.AddListener(OnBackBendingWeakClick);
			uiBackBendingStrong.button.onClick.AddListener(OnBackBendingStrongClick);
			
			if(!core.worldUi.isCompact){
				uiHint4.button.onClick.AddListener(OnHint4Click);
			}
		}

		public void MakeMenuBodyPartConfig1(){
			uiExpressionOnButton       = MakeButton(strExpressionOnButtonVar, 0, line);
			uiBlushingOnButton         = MakeButton(strBlushingOnButtonVar, 1, line);
			uiTearsOnButton            = MakeButton(strTearsOnButtonVar, 2, line);
			uiDroolOnButton            = MakeButton(strDroolOnButtonVar, 3, line);			
			line++;
			
			uiAutoExpressionOnButton   = MakeButton(strAutoExpressionOnButtonVar, 0, line);	
			uiAutoBlinkOnButton        = MakeButton(strAutoBlinkOnButtonVar, 1, line);		
			uiEyesControlOnButton      = MakeButton(strEyesControlOnButtonVar, 2, line);
			uiEyesRollupOnButton       = MakeButton(strEyesRollupOnButtonVar, 3, line);		
			line++;
			
			uiExpressionOnButton.button.onClick.AddListener(OnExpressionOnButtonClick);
			uiBlushingOnButton.button.onClick.AddListener(OnBlushingOnButtonClick);
			uiTearsOnButton.button.onClick.AddListener(OnTearsOnButtonClick);
			uiDroolOnButton.button.onClick.AddListener(OnDroolOnButtonClick);			

			uiAutoExpressionOnButton.button.onClick.AddListener(OnAutoExpressionOnButtonClick);
			uiAutoBlinkOnButton.button.onClick.AddListener(OnAutoBlinkOnButtonClick);
			uiEyesControlOnButton.button.onClick.AddListener(OnEyesControlOnButtonClick);
			uiEyesRollupOnButton.button.onClick.AddListener(OnEyesRollupOnButtonClick);			
		}
		
		public void MakeMenuBodyPartConfig2(){
			uiPeeingOnButton           = MakeButton(strPeeingOnButtonVar, 0, line);			
			uiSoundOnButton            = MakeButton(strSoundOnButtonVar, 1, line);
			uiSoundVammButton          = MakeButton(strSoundVammButtonVar, 2, line);
			if(!core.worldUi.isCompact){
				uiHint10               = MakeButton(strHint10, 3, line);				
			}
			line++;
			
			uiHeadMotionOnButton       = MakeButton(strHeadMotionOnButtonVar, 0, line);
			uiToggleDoubleCollider     = MakeButton(strToggleDoubleColliderVar, 1, line);
			uiSensitiveTriggerButton   = MakeButton(strSensitiveTriggerVar, 2, line);
			uiAlterSkinWrapButton      = MakeButton(strAlterSkinWrapVar, 3, line);
			line++;
			
			uiPenisSupportButton       = MakeButton(strPenisSupportVar, 0, line);
			
			if(!core.worldUi.isCompact){
				uiHint2                    = MakeButton(strHint2, 1, line);
				uiHint5                    = MakeButton(strHint5, 2, line);
				uiHint11                   = MakeButton(strHint11, 3, line);
			}
			line++;
						
			uiSoundOnButton.button.onClick.AddListener(OnSoundOnButtonClick);
			uiSoundVammButton.button.onClick.AddListener(OnSoundVammButtonClick);
			uiPeeingOnButton.button.onClick.AddListener(OnPeeingOnButtonClick);		
			
			uiHeadMotionOnButton.button.onClick.AddListener(OnHeadMotionOnButtonClick);			
			uiToggleDoubleCollider.button.onClick.AddListener(OnToggleDoubleColliderClick);
			uiSensitiveTriggerButton.button.onClick.AddListener(OnSensitiveTriggerButtonClick);			
			uiAlterSkinWrapButton.button.onClick.AddListener(OnAlterSkinWrapButtonClick);			
			uiPenisSupportButton.button.onClick.AddListener(OnPenisSupportButtonClick);			
			
			if(!core.worldUi.isCompact){
				uiHint2.button.onClick.AddListener(OnHint2Click);
				uiHint5.button.onClick.AddListener(OnHint5Click);
				uiHint10.button.onClick.AddListener(OnHint10Click);
				uiHint11.button.onClick.AddListener(OnHint11Click);
			}
			
		}
		
		public void MakeMenuBodyPartConfig3(){
			uiAutoStopPluginsButton    = MakeButton(strAutoStopPluginsVar, 0, line);
			uiAutoStopMorphButton      = MakeButton(strAutoStopMorphVar,   1, line);
			uiAutoStopHeadButton       = MakeButton(strAutoStopHeadVar,    2, line);
			uiAutoStopBodyButton       = MakeButton(strAutoStopBodyVar,    3, line);
			line++;
			
			if(!core.worldUi.isCompact){
				uiHint3                    = MakeButton(strHint3, 0, line);
				uiHint6                    = MakeButton(strHint6, 1, line);
				uiHint7                    = MakeButton(strHint7, 2, line);
				uiHint8                    = MakeButton(strHint8, 3, line);
				line++;
			}
			
			uiAutoStopPluginsButton.button.onClick.AddListener(OnAutoStopPluginsClick);			
			uiAutoStopMorphButton.button.onClick.AddListener(  OnAutoStopMorphClick);			
			uiAutoStopHeadButton.button.onClick.AddListener(   OnAutoStopHeadClick);			
			uiAutoStopBodyButton.button.onClick.AddListener(   OnAutoStopBodyClick);			
			
			if(!core.worldUi.isCompact){
				uiHint3.button.onClick.AddListener(OnHint3Click);
				uiHint6.button.onClick.AddListener(OnHint6Click);
				uiHint7.button.onClick.AddListener(OnHint7Click);
				uiHint8.button.onClick.AddListener(OnHint8Click);
			}
		}
		
		public void MakeMenuBodyPartConfig4(){
			uiNippleErectionOnButton   = MakeButton(strNippleErectionOnButtonVar, 0, line);	
			uiClitorisErectionOnButton = MakeButton(strClitorisErectionOnButtonVar, 1, line);
			line++;
			uiNippleErectionOnButton.button.onClick.AddListener(OnNippleErectionOnButtonClick);
			uiClitorisErectionOnButton.button.onClick.AddListener(OnClitorisErectionOnButtonClick);
			
			if(core.orgasmModeOn){
				uiShiveringBoneButton   = MakeButton(strShiveringBoneVar,  0, line);
				uiShiveringMorphButton  = MakeButton(strShiveringMorphVar,  1, line);
				
				if(!core.worldUi.isCompact){
					uiHint9             = MakeButton(strHint9, 2, line);
				}
				line++;
				
				uiShiveringBoneButton.button.onClick.AddListener(OnShiveringBoneClick);			
				uiShiveringMorphButton.button.onClick.AddListener(OnShiveringMorphClick);			
				if(!core.worldUi.isCompact){
					uiHint9.button.onClick.AddListener(OnHint9Click);
				}
			}
		}
		
		public void MakeMenuBodyPartSlider1(){
			float gaugeMax = (float)core.stageThreshold[5] * 1.2f;
			uiGaugeSlider = MakeSlider(strGaugeSlider, 0, line, 0f, gaugeMax, (float)core.getGauge());				
			Image bgImage = uiGaugeSlider.GetComponentInChildren<Image>();
			bgImage.color = new Color(1f, 0.25f, 0.75f);
			uiGaugeSlider.labelText.color = new Color(1, 0, 0);

			if(!isCompact){
				uiStatusField = MakeTextField(strStatusField, quick1, line, width:buttonSizeX3, height:sliderSizeY);
			}
			line+= 1;
		}
		
		public void MakeMenuBodyPartSlider2(){
			if(core.orgasmModeOn){
				uiWaveSlider = MakeSlider(strWaveSlider, 0, line, 0f, 1000f, core.orgasmWaveCycleBigMax);
				uiWaveSlider.slider.onValueChanged.AddListener(OnWaveSliderChange);
				uiInstantWaveLow    = MakeButton(strInstantWaveLow,    quick1, line, width:buttonSizeX/4f, height:sliderSizeY);
				uiInstantWaveMiddle = MakeButton(strInstantWaveMiddle, quick2, line, width:buttonSizeX/4f, height:sliderSizeY);
				uiInstantWaveHigh   = MakeButton(strInstantWaveHigh,   quick3, line, width:buttonSizeX/4f, height:sliderSizeY);
				uiInstantWave999    = MakeButton(strInstantWave999,    quick4, line, width:buttonSizeX/4f, height:sliderSizeY);
				uiInstantWaveLow.button.onClick.AddListener(   OnInstantWaveLowClick);
				uiInstantWaveMiddle.button.onClick.AddListener(OnInstantWaveMiddleClick);
				uiInstantWaveHigh.button.onClick.AddListener(  OnInstantWaveHighClick);
				uiInstantWave999.button.onClick.AddListener(   OnInstantWave999Click);
				line += 2;
			}
			
			uiPitchSlider = MakeSlider(strPitchSlider, 0, line, 0.8f, 1.5f, core.sound.headAudioSource.pitch);
			uiPitchSlider.slider.onValueChanged.AddListener(OnPitchSliderChange);
			uiInstantSoundLow    = MakeButton(strInstantSoundLow,   quick1, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantSoundMiddle = MakeButton(strInstantSoundMiddle,quick2, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantSoundHigh   = MakeButton(strInstantSoundHigh,  quick3, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantSoundLow.button.onClick.AddListener(   OnInstantSoundLowClick);
			uiInstantSoundMiddle.button.onClick.AddListener(OnInstantSoundMiddleClick);
			uiInstantSoundHigh.button.onClick.AddListener(  OnInstantSoundHighClick);
			line += 2;
			
			uiStrengthSlider = MakeSlider(strStrengthSlider, 0, line, 0f, 1.5f, core.expression2.fmm.baseMultiplier);
			uiStrengthSlider.slider.onValueChanged.AddListener(OnStrengthSliderChange);
			uiInstantStrengthLow    = MakeButton(strInstantStrengthLow,    quick1, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantStrengthMiddle = MakeButton(strInstantStrengthMiddle, quick2, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantStrengthHigh   = MakeButton(strInstantStrengthHigh,   quick3, line, width:buttonSizeX/4f, height:sliderSizeY);
			uiInstantStrengthLow.button.onClick.AddListener(   OnInstantStrengthLowClick);
			uiInstantStrengthMiddle.button.onClick.AddListener(OnInstantStrengthMiddleClick);
			uiInstantStrengthHigh.button.onClick.AddListener(  OnInstantStrengthHighClick);
			line += 1;
		}
		
		public void RemoveMenuBody(){
			RemoveMenuBodyMain();
			worldUIAddon1.RemoveMenuBodyAddon();
			core.DoWorldUIAddon2Function("RemoveMenuBodyAddon");
		}

		public void RemoveTemporaryMenu(){
			RemoveMenuBodyTemporary();			
		}
		
		public void ColoringButton(UIDynamicButton[] buttons, float fR, float fG, float fB){
			foreach(UIDynamicButton button in buttons){
				ColoringButton(button, fR, fG, fB);
			}
		}
		
		public void ColoringButton(UIDynamicButton button, float fR, float fG, float fB){
			if(button != null){
				if(button.label.StartsWith("Hint") || button.label.StartsWith("Help")){
					button.buttonColor = new Color(255f/255f, 255f/255f, 180f/255f);
				}else{
					button.buttonColor = new Color(fR, fG, fB);	
				}
			}
		}
		
		public void ColoringTextField(UIDynamicTextField[] texts, float fR, float fG, float fB){
			foreach(UIDynamicTextField text in texts){
				if(text != null){
					text.backgroundColor = new Color(fR, fG, fB);	
				}
			}
		}
		
		public void Coloring(){
			try{
				UIDynamicButton[] baseButtons = {
					uiMinimizeMenu,
				};
				
				foreach(UIDynamicButton button in baseButtons){
					if(button != null){
						if(core.launchMode == "normal"){
							button.buttonColor = new Color(52f/255f, 164f/255f, 235f/255f);				
						}else if(core.launchMode == "paused"){
							button.buttonColor = new Color(128f/255f, 128f/255f, 128f/255f);				
						}
					}
				}
				
				
				UIDynamicButton[] buttons = {
					uiExpressionOnButton, uiBlushingOnButton, uiTearsOnButton, uiDroolOnButton, uiToggleDoubleCollider, 
					uiAutoStopPluginsButton, uiAutoStopMorphButton, uiAutoStopHeadButton, uiAutoStopBodyButton, 
					uiSensitiveTriggerButton, uiPenisSupportButton, uiAlterSkinWrapButton,
					uiAutoExpressionOnButton, uiAutoBlinkOnButton, uiEyesControlOnButton, uiEyesRollupOnButton, 
					uiSoundOnButton, uiSoundVammButton, uiPeeingOnButton, 
					uiNippleErectionOnButton, uiClitorisErectionOnButton, uiHeadMotionOnButton,
					uiInstantSoundLow,   uiInstantStrengthLow,   uiInstantWaveLow, 
					uiInstantSoundMiddle,uiInstantStrengthMiddle,uiInstantWaveMiddle,
					uiInstantSoundHigh,  uiInstantStrengthHigh,  uiInstantWaveHigh,  uiInstantWave999,
					uiHint2, uiHint3, uiHint4, uiHint5, uiHint6, uiHint7, uiHint8,
					uiShiveringBoneButton, uiShiveringMorphButton, uiHint9, uiHint10, uiHint11, 
				};
				ColoringButton(buttons, 198f/255f, 250f/255f, 192f/255f);

				UIDynamicSlider[] otherSliders = {
					uiStrengthSlider, uiPitchSlider,
					uiWaveSlider,
				};
				
				foreach(UIDynamicSlider slider in otherSliders){
					if(slider != null){
						Image bgImage = slider.GetComponentInChildren<Image>();
						bgImage.color = new Color(198f/255f, 250f/255f, 192f/255f);
					}
				}
				
				UIDynamicButton[] expandButtons = {
					uiExpandUI, uiExpandAction1, uiExpandAction2, 
					uiExpandConfig1, uiExpandConfig2, uiExpandConfig3, 
					uiExpandSlider1, uiExpandSlider2, 
					worldUIAddon1.uiExpandAddon1, uiExpandConfig4, 
				};
				ColoringButton(expandButtons, 235f/255f, 161f/255f, 52f/255f);

				UIDynamicTextField[] texts = {
					uiStatusField,
				};
				ColoringTextField(texts, 224f/255f, 192f/255f, 255f/255f);
				
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void RemoveMenuBodyTemporary(){
			UIDynamicButton[] buttons = {
				uiTemporaryButton,
			};
			
			UIDynamicTextField[] texts = {
				uiTemporaryText,
			};
			
			try{
				RemoveMenuBodyImpl(buttons, texts);
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void RemoveMenuBodyMain(){
			UIDynamicButton[] buttons = {
				uiMinimizeMenu, uiCloseMenu, uiOpenAtomMenu, uiCloseUI, uiChangeSize, 
				uiLookFrontUI, uiCompactMenu, 
				uiShiveringBoneButton, uiShiveringMorphButton,
				uiAutoStopPluginsButton, uiAutoStopMorphButton, uiAutoStopHeadButton, uiAutoStopBodyButton, 
				uiHint2, uiHint3, uiHint4, uiHint5, uiHint6, uiHint7, uiHint8, uiHint9, uiHint10, uiHint11, 
				uiReloadPlugins, uiCollapseUI, uiCollapseWOBarUI, uiExpandAllUI, uiReloadThisPluginOnly,
				uiResetExpressionButton, uiCalmDownButton, uiOrgasmButton, uiPeeButton, uiToggleDoubleCollider,
				uiStageUp, uiStageDown,
				uiFaceForward, uiFaceSideways, uiFaceSidewaysAlt, uiFaceSidewaysMax, 
				uiLookGlancing, uiBackBending, uiBackBendingStrong, uiSensitiveTriggerButton, 
				uiPenisSupportButton, uiAlterSkinWrapButton,
				uiExpressionOnButton, uiBlushingOnButton, uiTearsOnButton, uiDroolOnButton,
				uiAutoExpressionOnButton, uiAutoBlinkOnButton, uiEyesControlOnButton, uiEyesRollupOnButton, 
				uiSoundOnButton, uiSoundVammButton, uiPeeingOnButton, 
				uiNippleErectionOnButton, uiClitorisErectionOnButton, uiHeadMotionOnButton,

				uiExpandUI, uiExpandAction1, uiExpandAction2, 
				uiExpandConfig1, uiExpandConfig2, uiExpandConfig3, uiExpandConfig4, 
				uiExpandSlider1, uiExpandSlider2, uiPauseMenu,
				uiInstantSoundLow,   uiInstantStrengthLow,   uiInstantWaveLow,   
				uiInstantSoundMiddle,uiInstantStrengthMiddle,uiInstantWaveMiddle,
				uiInstantSoundHigh,  uiInstantStrengthHigh,  uiInstantWaveHigh,  uiInstantWave999,
			};

			UIDynamicSlider[] sliders = {
				uiStrengthSlider, uiWaveSlider, uiGaugeSlider, uiPitchSlider,
			};

			UIDynamicTextField[] texts = {
				uiStatusField,
			};
			
			RemoveMenuBodyImpl(buttons, sliders, texts);
		}

		public void RemoveMenuBodyImpl(UIDynamicButton[] buttons, UIDynamicSlider[] sliders, UIDynamicTextField[] texts = null){
			foreach(UIDynamicButton button in buttons){
				if(button != null){ plugin.RemoveButton(button);} 
			}
			
			foreach(UIDynamicSlider slider in sliders){
				if(slider != null){ Utility.RemoveSliderForCanvas(slider);}
			}			
			
			if(texts == null){ return; }
			
			foreach(UIDynamicTextField text in texts){
				if(text != null){ Utility.RemoveTextFieldForCanvas(text);}
			}
		}
		
		public void RemoveMenuBodyImpl(UIDynamicButton[] buttons, UIDynamicTextField[] texts){
			foreach(UIDynamicButton button in buttons){
				if(button != null){ plugin.RemoveButton(button);} 
			}
			
			foreach(UIDynamicTextField text in texts){
				if(text != null){ Utility.RemoveTextFieldForCanvas(text);}
			}
		}
		#endregion
		
		#region Define UI Function Main
		public void OnExpandCommon(string type){
			expandState[type] = expandState[type] ? false : true;
			RemoveMenuBody();
			MakeMenuBody();
		}
		
		public void OnExpandUI(){OnExpandCommon("UI");}
		public void OnExpandAction1(){OnExpandCommon("Action1");}
		public void OnExpandAction2(){OnExpandCommon("Action2");}
		public void OnExpandConfig1(){OnExpandCommon("Config1");}
		public void OnExpandConfig2(){OnExpandCommon("Config2");}
		public void OnExpandConfig3(){OnExpandCommon("Config3");}
		public void OnExpandConfig4(){OnExpandCommon("Config4");}
		public void OnExpandSlider1(){OnExpandCommon("Slider1");}
		public void OnExpandSlider2(){OnExpandCommon("Slider2");}
		
		public void OnCollapseUI(){OnExpandCommon("UI");}
		public void OnCollapseAction1(){OnExpandCommon("Action1");}
		public void OnCollapseAction2(){OnExpandCommon("Action2");}
		public void OnCollapseConfig1(){OnExpandCommon("Config1");}
		public void OnCollapseConfig2(){OnExpandCommon("Config2");}
		public void OnCollapseConfig3(){OnExpandCommon("Config3");}
		public void OnCollapseConfig4(){OnExpandCommon("Config4");}
		public void OnCollapseSlider1(){OnExpandCommon("Slider1");}
		public void OnCollapseSlider2(){OnExpandCommon("Slider2");}
		
		public void OnOrgasmButtonClick(){
			if(core.orgasmModeOn == false){
				if(core.getGauge() < core.stageThreshold[5]){
					core.setGauge(core.stageThreshold[5]);
					core.OnErogenousZoneTouch("VaginaDeeper");
					core.updateAll();
				}
			}else{
				if(core.orgasmModeOn){
					if(uiOrgasmButton.label == strOrgasmButton){
						if(core.getGauge() < core.stageThreshold[5]){
							core.setGauge(core.stageThreshold[5]);
							core.OnErogenousZoneTouch("VaginaDeeper");
							core.updateAll();
						}
					}else{
						core.setGauge(core.stageThreshold[0]);
						core.orgasmFunctions("orgasmFinish", 0f);						
					}
				}
			}
		}

		public void OnWaveSliderChange(float value){
			try{
				core.orgasmWaveCycleBigMax = (int)value;
				if(core.customUi.dJSSlider["Orgasm Wave Big Cycle Count Max"].slider != null){
					core.customUi.dJSSlider["Orgasm Wave Big Cycle Count Max"].slider.value = value;
				}
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void OnInstantWaveLowClick(){
			OnInstantWaveClickCommon(5f);
		}

		public void OnInstantWaveMiddleClick(){
			OnInstantWaveClickCommon(10f);
		}

		public void OnInstantWaveHighClick(){
			OnInstantWaveClickCommon(20f);
		}

		public void OnInstantWave999Click(){
			OnInstantWaveClickCommon(999f);
		}

		public void OnInstantWaveClickCommon(float value){
			core.orgasmWaveCycleBigMax = (int)value;
			uiWaveSlider.slider.value = (int)value;
		}		

		public void OnInstantSoundLowClick(){
			OnInstantSoundClickCommon(0.95f);
		}

		public void OnInstantSoundMiddleClick(){
			OnInstantSoundClickCommon(1.0f);
		}

		public void OnInstantSoundHighClick(){
			OnInstantSoundClickCommon(1.2f);
		}

		public void OnInstantSoundClickCommon(float value){
			core.sound.headAudioSource.pitch = value;
			uiPitchSlider.sliderControl.setSliderToValue(value);
		}
		
		public void OnInstantStrengthLowClick(){
			OnInstantStrengthClickCommon(0.8f);
		}

		public void OnInstantStrengthMiddleClick(){
			OnInstantStrengthClickCommon(1.0f);
		}

		public void OnInstantStrengthHighClick(){
			OnInstantStrengthClickCommon(1.1f);
		}

		public void OnInstantStrengthClickCommon(float value){
			core.expression2.fmm.baseMultiplier = value;
			uiStrengthSlider.slider.value = value;
		}
		
		public void OnCloseMenuClick(){
			core.customUi.dJSToggle["Display UI Menu"].SetVal(false);
			RemoveMenuBody();
			core.customUi.changeButtonColoring();
			core.RemoveGameObjectByName("SphereForUICorner");
		}

		public void OnMinimizeMenuClick(){
			canvasPos = Utility.getPosition(core.UIAtom.mainController.transform.position);
			RemoveMenuBody();
			MakeMenuBodyPartMinAlt();
		}

		public void OnPauseClick(){
			core.launchMode = "paused";
			canvasPos = Utility.getPosition(core.UIAtom.mainController.transform.position);
			RemoveMenuBody();
			MakeMenuBodyPartMinAltPaused();
		}
		
		public void OnPauseEndClick(){
			core.launchMode = "normal";
			plugin.RemoveButton(uiMinimizeMenu);
			plugin.RemoveButton(uiPauseMenu);
			MakeMenuBodyPartMinAlt();
		}
		
		public void OnCompactClick(){
			if(strCompactMenuVar == strCompactMenu){
				isCompact = true;
				strCompactMenuVar = isCompact ? strCompactMenuAlt : strCompactMenu;
				ReloadMenu();
			}else{
				isCompact = false;
				strCompactMenuVar = isCompact ? strCompactMenuAlt : strCompactMenu;
				ReloadMenu();
			}
		}
		
		public void OnCollapseWOBarUIClick(){
			if(strCollapseWOBarVar == strCollapseWOBarUI){
				isBarOnly = true;
				strCollapseWOBarVar = isBarOnly ? strCollapseWOBarUIAlt : strCollapseWOBarUI;
				SetExpandValue("BarOnly");
			}else{
				isBarOnly = false;
				strCollapseWOBarVar = isBarOnly ? strCollapseWOBarUIAlt : strCollapseWOBarUI;
				SetExpandValue("Recovery");
			}
			LabelSwitch();
			ReloadMenu();
		}

		public void ExpandMenu(){
			plugin.RemoveButton(uiMinimizeMenu);
			plugin.RemoveButton(uiPauseMenu);
			plugin.RemoveButton(uiCompactMenu);
			plugin.RemoveButton(uiCollapseWOBarUI);
			MakeMenuBody();
			LabelSwitch();
		}
		
		public void ReloadMenu(){
			RemoveMenuBody();
			MakeMenuBodyIfNeeded();
		}

		public void OnCollapseUIClick(){
			SetExpandValue("Collapse");
			ReloadMenu();
		}

		public void OnExpandAllUIClick(){
			SetExpandValue("Expand");
			ReloadMenu();
		}

		public void OnOpenAtomMenuClick(){
			Utility.OpenAtomUI(core.atom);
		}
		
		public void OnCloseUIClick(){
			Utility.CloseUI();
		}
		
		public void OnLookFrontClick(){
			Utility.LookFront(canvas.transform);
		}

		public void OnReloadPluginsClick(){
			try{
				Utility.ReloadPlugins(core.atom);
			}catch(Exception e){
				core.loggerE(e);
			}
		}

		public void OnReloadThisPluginOnlyClick(){
			try{
				Utility.ReloadButtonClick(core.atom, "EBATCore");
			}catch(Exception e){
				core.loggerE(e);
			}
		}

		public void OnChangeSizeClick(){
			if(uiChangeSize.label == strChangeSize){
				isSmall = true;
				strChangeSizeVar = strChangeSizeAlt;
				uiChangeSize.label = strChangeSizeVar;
			}else{
				isSmall = false;
				strChangeSizeVar = strChangeSize;
				uiChangeSize.label = strChangeSizeVar;				
			}
			RemoveMenuBody();
			MakeMenuBody();
		}
		
		public void OnPeeButtonClick(){
			if(core.customUnityAssetItem.peeingOnGlobal){
				if(core.getGauge() < core.stageThreshold[2]){
					core.setGauge(core.stageThreshold[2]);
					core.OnErogenousZoneTouch("VaginaDeeper");						
				}
				core.customUnityAssetItem.peeRandom(core.getTime(), true);
			}
			
			DAZCharacterSelector character = core.atom.GetStorableByID("geometry") as DAZCharacterSelector;
			var ui = character.selectedCharacter.transform;			
		}

		public void OnResetExpressionButton(){
			core.expression2.resetExpression();
		}

		public void OnStageUp(){
			int stage = core.getStage();
			stage += (stage == 5) ? 0 : 1;
			core.setStage(stage);
			core.OnErogenousZoneTouch("VaginaDeeper");
			if(stage == 5){
				core.updateAll();
				core.orgasmFunctions("orgasmStart", 0f);				
			}
		}

		public void OnStageDown(){
			int stage = core.getStage();
			stage -= (stage == 0) ? 0 : 1;
			core.setStage(stage);
			if(stage == 4){
				core.orgasmFunctions("orgasmFinish", 0f);
			}
		}

		public void OnFaceForwardClick(){
			core.headController.HeadMotion("Face Forward", true);
		}

		public void OnFaceSidewaysClick(){
			core.headController.HeadMotion("Face Sideways 1", true);
		}

		public void OnFaceSidewaysAltClick(){
			core.headController.HeadMotion("Face Sideways 2", true);
		}

		public void OnFaceSidewaysMaxClick(){
			core.headController.HeadMotion("Face Sideways 3", true);
		}

		public void OnLookGlancingClick(){
			core.headController.HeadMotion("Glance", true);
		}

		public void OnBackBendingWeakClick(){
			core.headController.HeadMotion("Turn Head Back 1", true);
		}

		public void OnBackBendingStrongClick(){
			core.headController.HeadMotion("Turn Head Back 2", true);
		}

		public void OnHint2Click(){
			core.hint.DoublingColliderHint();
		}

		public void OnHint3Click(){
			core.hint.AutoStopHint();
		}

		public void OnHint4Click(){
			core.hint.FaceSidewaysHint();
		}

		public void OnHint5Click(){
			core.hint.SensitiveTriggerHint();
		}

		public void OnHint6Click(){
			core.hint.customUiHint("Hint:[AS]Stop Morph Control by non-plugins");
		}

		public void OnHint7Click(){
			core.hint.customUiHint("Hint:[AS]Stop Head Control by non-plugins");
		}

		public void OnHint8Click(){
			core.hint.customUiHint("Hint:[AS]Stop Body Control by non-plugins");
		}

		public void OnHint9Click(){
			core.hint.ShiveringHint();
		}

		public void OnHint10Click(){
			core.hint.VAMMoanHint();
		}

		public void OnHint11Click(){
			core.hint.SkinWrapHint();
		}

		public void OnCalmDownButtonClick(){
			core.orgasmFunctions("orgasmFinish", 0f);
			core.setGauge(0);
			core.orgasmCount = 0;
			core.hasMultipleOrgasms = false;
			core.tears.refreshTears();
			core.expression2.resetExpression();
			core.soundExternalLinkage.StopVamm();
			core.OnStageChange();
		}
		
		public void UpdateStatus(){
			if(uiStatusField == null){ return; };
			if(isCompact){ return; };
			
			string status = strGenderSVar + " is not sexually aroused at all.";
			string th = "th";
			if(core.curStage == 1){
				th = "st";
			}else if(core.curStage == 2){
				th = "nd";
			}else if(core.curStage == 3){
				th = "rd";
			}
			if(core.curStage >= 1){
				status = strGenderSVar + " is on the " + core.curStage + th + " level of arousal. ";
			}
			if(!core.isHot){
				status += strGenderSVar + " is calm.";
			}else{
				if(core.isDuringAfterglow){
					status += strGenderSVar + " is having a lingering orgasm. ";
				}else if(core.isDuringOrgasm){
					if(core.hasMultipleOrgasms){
						status += strGenderSVar + " is having multiple orgasms. ";
					}else{
						status += strGenderSVar + " is having an orgasm. ";
					}
				}else{
					status += strGenderSVar + " is sexually aroused. ";
				}
				if(core.orgasmCount == 0){
				}else if(core.orgasmCount == 1){
					status += strGenderSVar + " has already reached " + strGenderPVar + " climax. ";
				}else{
					status += strGenderSVar + " had already climaxed " + core.orgasmCount + " times. ";
				}
			}
			if(core.customUnityAssetItem.isPeeFree == false){
				status += strGenderSVar + " has squirted. ";
			}
			
			uiStatusField.text = status;
		}
		
		public void LabelSwitchPauseOnly(){
			LabelVarChangePauseOnly();
			LabelUpdatePauseOnly();
		}
		
		public void LabelVarChangePauseOnly(){
			strPauseMenuVar = core.launchMode == "paused" ? strPauseMenuAlt : strPauseMenu;
		}
		
		public void LabelUpdatePauseOnly(){
			uiPauseMenu.label			    = strPauseMenuVar;			
		}
		
		public void LabelSwitch(){
			try{
			LabelVarChange();
			LabelUpdate();
			core.DoWorldUIAddon2Function("LabelSwitch");
				
			}catch(Exception e){
				core.loggerE(e);
			}
			
		}
				
		public void LabelVarChange(){
			strPauseMenuVar = core.launchMode == "paused" ? strPauseMenuAlt : strPauseMenu;
			strCollapseWOBarVar = isBarOnly ? strCollapseWOBarUIAlt : strCollapseWOBarUI;
			strChangeSizeVar = isSmall ? strChangeSizeAlt : strChangeSize;
			strSoundOnButtonVar = (core.sound.soundOnGlobal) ? strSoundOnButtonOn : strSoundOnButtonOff;
			strSoundVammButtonVar = (core.vammoanLinkOnGlobal) ? strSoundVammButtonOn : strSoundVammButtonOff;
			strTearsOnButtonVar = (core.tears.tearsOnGlobal) ? strTearsOnButtonOn : strTearsOnButtonOff;
			strEyesControlOnButtonVar = (core.eyesControl.eyecontrolOnGlobal) ? strEyesControlOnButtonOn : strEyesControlOnButtonOff;
			strExpressionOnButtonVar = (core.expression2.expressionOnGlobal) ? strExpressionOnButtonOn : strExpressionOnButtonOff;
			strBlushingOnButtonVar = (core.blushing.blushOnGlobal) ? strBlushingOnButtonOn : strBlushingOnButtonOff;
						
			strDroolOnButtonVar = (core.tears.droolOnGlobal) ? strDroolOnButtonOn : strDroolOnButtonOff;
			strEyesRollupOnButtonVar = (core.eyesControl.eyecontrolRollupOnGlobal) ? strEyesRollupOnButtonOn : strEyesRollupOnButtonOff;
			strNippleErectionOnButtonVar = (core.bodyMorph.nippleErectionOnGlobal) ? strNippleErectionOnButtonOn : strNippleErectionOnButtonOff;
			strClitorisErectionOnButtonVar = (core.bodyMorph.clitorisErectionOnGlobal) ? strClitorisErectionOnButtonOn : strClitorisErectionOnButtonOff;
			strHeadMotionOnButtonVar = (core.headController.headMotionOnGlobal) ? strHeadMotionOnButtonON : strHeadMotionOnButtonOff;
			strPeeingOnButtonVar = (core.customUnityAssetItem.peeingOnGlobal) ? strPeeingOnButtonOn : strPeeingOnButtonOff;
						
			strAutoExpressionOnButtonVar = (core.etc.autoExpressionOffGlobal) ? strAutoExpressionOnButtonOn : strAutoExpressionOnButtonOff;
			strAutoBlinkOnButtonVar = (core.etc.autoBlinkOffGlobal) ? strAutoBlinkOnButtonOn : strAutoBlinkOnButtonOff;
			strToggleDoubleColliderVar = (core.collider2xOnGlobal) ? strToggleDoubleColliderOn : strToggleDoubleColliderOff;
			strSensitiveTriggerVar = (core.sensitiveTriggerOnGlobal) ? strSensitiveTriggerOn : strSensitiveTriggerOff;
			strPenisSupportVar = (core.addonManager1.manController.penisSupportOnGlobal) ? strPenisSupportOn : strPenisSupportOff;
			strAlterSkinWrapVar = (core.addonManager1.addonClothSim.wrapChangeOnGlobal) ? strAlterSkinWrapOn : strAlterSkinWrapOff;
			
			strAutoStopPluginsVar = (core.addonManager1.addonTakeControl.autoStopOnGlobal) ? strAutoStopPluginsOn : strAutoStopPluginsOff;
			strAutoStopMorphVar   = (core.addonManager1.addonTakeControl.autoStopMorphOnGlobal) ? strAutoStopMorphOn : strAutoStopMorphOff;
			strAutoStopHeadVar    = (core.addonManager1.addonTakeControl.autoStopHeadOnGlobal)  ? strAutoStopHeadOn  : strAutoStopHeadOff;
			strAutoStopBodyVar    = (core.addonManager1.addonTakeControl.autoStopBodyOnGlobal)  ? strAutoStopBodyOn  : strAutoStopBodyOff;

			if(core.orgasmModeOn){
				strShiveringBoneVar   = (core.bellyBoneOn)  ? strShiveringBoneOn  : strShiveringBoneOff;
				strShiveringMorphVar  = (core.bellyMorphOn) ? strShiveringMorphOn : strShiveringMorphOff;
			}
		}
		
		public void LabelUpdate(){
			uiChangeSize.label              = strChangeSizeVar;
			uiCollapseWOBarUI.label         = strCollapseWOBarVar;
			uiSoundOnButton.label			= strSoundOnButtonVar;
			uiSoundVammButton.label			= strSoundVammButtonVar;
			uiTearsOnButton.label			= strTearsOnButtonVar;
			uiEyesControlOnButton.label		= strEyesControlOnButtonVar;
			uiExpressionOnButton.label		= strExpressionOnButtonVar;
			uiBlushingOnButton.label		= strBlushingOnButtonVar;
			uiDroolOnButton.label			= strDroolOnButtonVar;
			uiEyesRollupOnButton.label		= strEyesRollupOnButtonVar;
			uiNippleErectionOnButton.label	= strNippleErectionOnButtonVar;
			uiClitorisErectionOnButton.label= strClitorisErectionOnButtonVar;
			uiHeadMotionOnButton.label      = strHeadMotionOnButtonVar;
			uiPeeingOnButton.label			= strPeeingOnButtonVar;
			uiAutoExpressionOnButton.label	= strAutoExpressionOnButtonVar;
			uiAutoBlinkOnButton.label		= strAutoBlinkOnButtonVar;
			uiPauseMenu.label			    = strPauseMenuVar;
			uiToggleDoubleCollider.label    = strToggleDoubleColliderVar;
			uiAutoStopPluginsButton.label   = strAutoStopPluginsVar;
			uiAutoStopMorphButton.label     = strAutoStopMorphVar;
			uiAutoStopHeadButton.label      = strAutoStopHeadVar;
			uiAutoStopBodyButton.label      = strAutoStopBodyVar;
			uiSensitiveTriggerButton.label  = strSensitiveTriggerVar;
			uiPenisSupportButton.label      = strPenisSupportVar;
			uiAlterSkinWrapButton.label     = strAlterSkinWrapVar;
			if(core.orgasmModeOn){
				uiShiveringBoneButton.label     = strShiveringBoneVar;
				uiShiveringMorphButton.label    = strShiveringMorphVar;
			}
		}
		
		public void NotifyToUser(string text, int fontSize = 48, float width = 800f, float height = 400f){
			if(uiTemporaryText){
				RemoveMenuBodyTemporary();
			}
			uiTemporaryText = MakeTextFieldTemporary(text, width, height, fontSize);
			uiTemporaryButton = MakeButtonTemporary(100f, 60f, 0.35f, -0.05f, fontSize);
			uiTemporaryButton.button.onClick.AddListener(OnTemporaryButtonClick);
			UIDynamicTextField[] texts = {
				uiTemporaryText,
			};
			ColoringTextField(texts, 160f/255f, 240f/255f, 224f/255f);
		}
		
		public void OnTemporaryButtonClick(){
			RemoveTemporaryMenu();
		}
		
		public void OnSoundOnButtonClick(){
			core.customUi.ToggleExternal("Sound On");
			LabelSwitch();
		}
		
		public void OnSoundVammButtonClick(){
			core.customUi.ToggleExternal("Use VAMMoan for Sound");
			LabelSwitch();
		}
		
		public void OnTearsOnButtonClick(){
			core.customUi.ToggleExternal("Tears On");
			LabelSwitch();
		}
		
		public void OnExpressionOnButtonClick(){
			core.customUi.ToggleExternal("Expression On");
			LabelSwitch();
		}
		
		public void OnBlushingOnButtonClick(){
			core.customUi.ToggleExternal("Blush On");
			LabelSwitch();
		}
		
		public void OnEyesControlOnButtonClick(){
			core.customUi.ToggleExternal("Eyes Control On");
			LabelSwitch();
		}
		
		public void OnDroolOnButtonClick(){
			core.customUi.ToggleExternal("Drool On");
			LabelSwitch();
		}
		
		public void OnEyesRollupOnButtonClick(){
			core.customUi.ToggleExternal("Eyes Rollup On");
			LabelSwitch();
		}
		
		public void OnNippleErectionOnButtonClick(){
			core.customUi.ToggleExternal("Nipple Erection On");
			LabelSwitch();
		}
		
		public void OnClitorisErectionOnButtonClick(){
			core.customUi.ToggleExternal("Clitoris Erection On");
			LabelSwitch();
		}
		
		public void OnHeadMotionOnButtonClick(){
			core.customUi.ToggleExternal("Head Motion On");
			LabelSwitch();
		}
		
		public void OnSensitiveTriggerButtonClick(){
			core.customUi.ToggleExternal("Sensitive Trigger");
			LabelSwitch();
		}
		
		public void OnPenisSupportButtonClick(){
			core.customUi.ToggleExternal("Penis Support");
			LabelSwitch();
		}
		
		public void OnAlterSkinWrapButtonClick(){
			core.customUi.ToggleExternal("Alter SkinWrap");
			LabelSwitch();
		}
		
		public void OnShiveringBoneClick(){
			core.customUi.ToggleExternal("Shivering during climax(bone)");
			LabelSwitch();
		}
		
		public void OnShiveringMorphClick(){
			core.customUi.ToggleExternal("Shivering during climax(morph)");
			LabelSwitch();
		}
		
		public void OnPeeingOnButtonClick(){
			try{
				core.customUi.ToggleExternal("Peeing On");
				LabelSwitch();
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void OnAutoExpressionOnButtonClick(){
			core.customUi.ToggleExternal("Auto Expression Off");
			LabelSwitch();
		}
		
		public void OnAutoBlinkOnButtonClick(){
			core.customUi.ToggleExternal("Auto Blink Off");
			LabelSwitch();
		}

		public void OnToggleDoubleColliderClick(){
			core.customUi.ToggleExternal("2x Collider Radius");
			LabelSwitch();
		}
				
		public void OnAutoStopPluginsClick(){
			core.customUi.ToggleExternal("OnOff:AutoStop Other Plugins");
			LabelSwitch();
		}
				
		public void OnAutoStopMorphClick(){
			core.customUi.ToggleExternal("OnOff:Stop Morph Control by non-plugins");
			LabelSwitch();
		}
				
		public void OnAutoStopHeadClick(){
			core.customUi.ToggleExternal("OnOff:Stop Head Control by non-plugins");
			LabelSwitch();
		}
				
		public void OnAutoStopBodyClick(){
			core.customUi.ToggleExternal("OnOff:Stop Body Control by non-plugins");
			LabelSwitch();
		}
				
		public void OnStrengthSliderChange(float value){
			try{
				core.expression2.fmm.baseMultiplier = value;
				if(core.customUi.dJSSlider["Expression Strength"].slider != null){
					core.customUi.dJSSlider["Expression Strength"].slider.value = value;
				}
			}catch(Exception e){
				core.loggerE(e);
			}
		}

		public void OnPitchSliderChange(float value){
			try{
				core.sound.headAudioSource.pitch = value;
				if(core.customUi.dJSSlider["Sound Pitch"].slider != null){
					core.customUi.dJSSlider["Sound Pitch"].slider.value = value;
				}
			}catch(Exception e){
				core.loggerE(e);
			}
		}

		public void OnOrgasmStart()
		{
			if(core.orgasmModeOn){
				strOrgasmButtonVar = strOrgasmButtonAlt;
				uiOrgasmButton.label = strOrgasmButtonVar;
			}
		}
		
		public void OnOrgasmStop()
		{
			if(core.orgasmModeOn){
				strOrgasmButtonVar = strOrgasmButton;
				uiOrgasmButton.label = strOrgasmButtonVar;
			}
		}
		#endregion
		
		#region Define Alias
		public float getWidth(string type, float width, bool isHeader = false){
			float size = buttonSizeX;
			if(type == "button"){
				size    = buttonSizeX;
			}else if(type == "buttonAlt"){
				size    = buttonSizeMinimizeX;
			}else if(type == "spacer"){
				size    = spacerSizeX;
				return size * (isSmall ? smallRatio * smallRatioForSize : 1.0f);				
			}else if(type == "toggle"){
				size    = toggleSizeX;
			}else if(type == "slider"){
				size    = sliderSizeX;
			}
			if(isHeader && type != "buttonAlt"){
				size = headerX;
			}
			
			if(width != 0f){
				return width * (isSmall ? smallRatio * smallRatioForSize : 1.0f);
			}else{
				return size * (isSmall ? smallRatio * smallRatioForSize : 1.0f);
			}
		}
		
		public float getHeight(string type, float height){
			float size = buttonSizeY;
			if(type == "button"){
				size    = buttonSizeY;
			}else if(type == "buttonAlt"){
				size    = buttonSizeY;
			}else if(type == "spacer"){
				size    = spacerSizeY;
			}else if(type == "toggle"){
				size    = toggleSizeY;
			}else if(type == "slider"){
				size    = sliderSizeY;
			}
			if(height != 0f){
				return height * (isSmall ? smallRatio : 1.0f);
			}else{
				return size * (isSmall ? smallRatio : 1.0f);
			}
		}
		
		public float getXPos(int x, bool isMinimizeButton = false, bool isMinisizeButton = false){
			return getXPos((float)x, isMinimizeButton, isMinisizeButton);
		}
		
		public float getXPos(float x, bool isMinimizeButton = false, bool isMinisizeButton = false){
			if(isMinimizeButton){
				return xOffsetMinimize * (isSmall ? smallRatio : 1.0f);
			}else if(x == -1){
				return xOffset * (isSmall ? smallRatio : 1.0f);
			}else if(isMinisizeButton){
				return xIndent + (xOffset + xSpacing * 0.4f * x) * (isSmall ? smallRatio * 1.2f : 1.0f);
			}else{
				return xIndent + (xOffset + xSpacing * x) * (isSmall ? smallRatio : 1.0f);
			}			
		}
		
		public float getYPos(int y){
			return (yOffset + ySpacing * y) * (isSmall ? smallRatio : 1.0f);
		}
		
		public int getFontSize(){
			return isSmall ? fontSizeAlt : fontSize;
		}
		
		public UIDynamic MakeSpacer(int x, int y, float width = 0f, float height = 0f){
			width = getWidth("spacer", width, x == -1);
			height = getHeight("spacer", height);
			float xpos = getXPos(x);
			float ypos = getYPos(y);
			
			UIDynamic uiSpacer = Utility.CreateSpacer(plugin, canvas, width, height);
			Utility.TranslateUI(uiSpacer, xpos, ypos);
			return uiSpacer;
		}
		
		public UIDynamicButton MakeButtonTemporary(float width = 100f, float height = 60f, float xpos = 0.25f, float ypos = -0.05f, int fontSize = 50){
			UIDynamicButton uiButton = Utility.CreateButton(plugin, canvasTemporary, "OK", width, height, fontSize);
			Utility.TranslateUI(uiButton, xpos, ypos);
			return uiButton;
		}
		
		public UIDynamicButton MakeButton(string name, float x, int y, float width = 0f, float height = 0f, bool isMinimizeButton = false, bool isMinisizeButton = false){
			int fontSizeVar = getFontSize();
			string type = isMinimizeButton ? "buttonAlt" : "button";
			width = getWidth(type, width, x == -1);
			height = getHeight(type, height);				
			float xpos = getXPos(x, isMinimizeButton, isMinisizeButton);
			float ypos = getYPos(y);
			
			UIDynamicButton uiButton = Utility.CreateButton(plugin, canvas, name, width, height, fontSizeVar);
			Utility.TranslateUI(uiButton, xpos, ypos);
			return uiButton;
		}
		
		public UIDynamicTextField MakeTextField(string text, float x, int y, float width = 0f, float height = 0f, bool isMinimizeButton = false){
			int fontSizeVar = getFontSize();
			string type = isMinimizeButton ? "buttonAlt" : "button";
			width = getWidth(type, width, x == -1);
			height = getHeight(type, height);				
			float xpos = getXPos(x, isMinimizeButton);
			float ypos = getYPos(y);
			
			UIDynamicTextField uiText = Utility.CreateTextField(plugin, canvas, text, width, height, fontSizeVar);
			Utility.TranslateUI(uiText, xpos, ypos);
			return uiText;
		}
		
		public UIDynamicTextField MakeTextFieldTemporary(string text, float width = 0f, float height = 0f, int fontSize = 50){
			UIDynamicTextField uiText = Utility.CreateTextField(plugin, canvasTemporary, text, width, height, fontSize);
			return uiText;
		}
		
		public UIDynamicButton MakeButton(string name, int x, int y, float width = 0f, float height = 0f, bool isMinimizeButton = false, bool isMinisizeButton = false){
			return MakeButton(name, (float)x, y, width, height, isMinimizeButton, isMinisizeButton);
		}
		
		public UIDynamicButton MakeButtonForAddon(string name, int x, int y, float width = 0f, float height = 0f){
			return MakeButton(name, x, y, width, height);
		}		
		
		public UIDynamicTextField MakeTextFieldForAddon(string name, int x, int y, float width = 0f, float height = 0f){
			return MakeTextField(name, x, y, width, height);
		}		
		
		public UIDynamicToggle MakeToggle(string name, int x, int y, float width = 0f, float height = 0f){
			try{
			int fontSizeVar = getFontSize();
			width = getWidth("toggle", width, x == -1);
			height = getHeight("toggle", height);
			float xpos = getXPos(x);
			float ypos = getYPos(y);
			
			UIDynamicToggle uiToggle = Utility.CreateToggle(plugin, canvas, name, width, height, fontSizeVar);
			Utility.TranslateUI(uiToggle, xpos, ypos);
			return uiToggle;
				
			}catch(Exception e){
				core.loggerE(e);
				return null;
			}
		}
		
		public UIDynamicSlider MakeSlider(string name, int x, int y, float min, float max, float current){
			int fontSizeVar = getFontSize();
			float width = getWidth("slider", 0, x == -1);
			float height = getHeight("slider", 0);
			float xpos = getXPos(x);
			float ypos = getYPos(y);
			
			UIDynamicSlider uiSlider = Utility.CreateSliderAlt(plugin, canvas, name, width, height, min, max, current, true, fontSizeVar, isSmall ? smallRatio : 1.0f);
			Utility.TranslateUI(uiSlider, xpos, ypos);
			return uiSlider;
		}
		
		#endregion
	}
}
