using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using Object = UnityEngine.Object;
using System.Text.RegularExpressions;

namespace Cotyounoyume
{
    public class AddonManager1 : MonoBehaviour 
    {
		public Atom atom;
		public EBATCore core;
		private float lastTime;
		
		public AddonClothSimItem addonClothSim;
		public AddonTakeControlItem addonTakeControl;
		public ManController manController;
		
		public AddonManager1(EBATCore core){
			atom = core.atom;
			this.core = core;
			
			addonClothSim         = new AddonClothSimItem(core);
			addonTakeControl      = new AddonTakeControlItem(core);
			manController         = new ManController(core);
		}
		
		public void loadSettings(){
			try{
				addonClothSim.loadSettings();
				addonTakeControl.loadSettings();
				manController.loadSettings();
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void applySettings(){
			addonClothSim.applySettings();
			addonTakeControl.applySettings();
			manController.applySettings();
		}

		public void manage(float time){
			if(time == lastTime){
				time += 0.001f;
			}else if(time < lastTime){
				time = lastTime + 0.001f;
			}
			lastTime = time;

			addonClothSim.manage(time);
			addonTakeControl.manage(time);
			manController.manage(time);
		}	
		
		public void OnDestroy(){
			addonClothSim.OnDestroy();
			addonTakeControl.OnDestroy();
			manController.OnDestroy();
		}
		
		public void OnOrgasmStart()
		{
			addonClothSim.OnOrgasmStart();
			addonTakeControl.OnOrgasmStart();
			manController.OnOrgasmStart();
		}
		
		public void OnOrgasmStop()
		{
			addonClothSim.OnOrgasmStop();
			addonTakeControl.OnOrgasmStop();
			manController.OnOrgasmStop();
		}
	}
}